AddCSLuaFile("autorun/HL2Settings.lua")

hl2s_maxammo_357=12
hl2s_maxammo_AR2=60
hl2s_maxammo_AR2AltFire=3
hl2s_maxammo_Buckshot=30
hl2s_maxammo_XBowBolt=10
hl2s_maxammo_Grenade=5
hl2s_maxammo_slam=5
hl2s_maxammo_Pistol=150
hl2s_maxammo_RPG_Round=3
hl2s_maxammo_SMG1=225
hl2s_maxammo_SMG1_Grenade=3

if SERVER then
	if !ConVarExists("hl2s_difficulty") then CreateConVar("hl2s_difficulty", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE}) end
	if !ConVarExists("hl2s_speed") then CreateConVar("hl2s_speed", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE}) end
	if !ConVarExists("hl2s_energy") then CreateConVar("hl2s_energy", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE}) end
	if !ConVarExists("hl2s_drowning") then CreateConVar("hl2s_drowning", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE}) end
	if !ConVarExists("hl2s_ammolimit") then CreateConVar("hl2s_ammolimit", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE}) end
end

function hl2s_Init()
	if SERVER then
	timer.Simple( 0.6, function()
		game.ConsoleCommand("sk_allow_autoaim 0\n")
		if GetConVarNumber("hl2s_difficulty")>0 then
			game.ConsoleCommand("skill 3\n")
			HL2s_HL2Difficulty()
			if GetConVarNumber("hl2s_difficulty")>1 then
				HL2s_ImpDifficulty()
			end
		end
	end)
	end
end

function hl2s_PlayerSpawned( ply )
	if ply:IsOnFire() then ply:Extinguish() end
	timer.Simple( 0.05, function()
		if ply and ply:IsValid() and GetConVarNumber("hl2s_speed")>0 then
			GAMEMODE:SetPlayerSpeed(ply, 190, 320)
		end
	end)
end

function hl2s_PlayerDied(ply, attacker, dmginfo)
	if GetConVarNumber("hl2s_energy")>0 then
		ply.HL2s_SprintTime=14
		ply.HL2s_SprintDisabled=0
		umsg.Start("HL2s-updatesprint", ply)
		umsg.Short(ply.HL2s_SprintTime)
		umsg.End()
	end
end

hook.Add( "DoPlayerDeath", "HL2s-PlayerDied", hl2s_PlayerDied )
hook.Add( "InitPostEntity", "HL2s-Init", hl2s_Init )
hook.Add( "PlayerSpawn", "HL2s-PlayerSpawned", hl2s_PlayerSpawned )

		if SERVER then

function hl2s_DamagedSomething( ent, inflictor, attacker, amount, dmginfo )
	if GetConVarNumber("hl2s_difficulty")>0 and ent and ent:IsValid() and attacker and attacker:IsValid() and attacker:IsNPC() then
		if attacker:GetClass()=="npc_barnacle" then dmginfo:SetDamage(146) end
		if GetConVarNumber("hl2s_difficulty")>1 then
			if attacker:GetClass()=="npc_manhack" then dmginfo:SetDamage(48) end
			if attacker:GetClass()=="npc_fastzombie" or attacker:GetClass()=="npc_fastzombie_torso" then dmginfo:SetDamage(34) end
			if attacker:GetClass()=="npc_headcrab_black" or attacker:GetClass()=="npc_headcrab_poison" then dmginfo:SetDamage(103) end
		else
			if attacker:GetClass()=="npc_manhack" then dmginfo:SetDamage(22) end
			if attacker:GetClass()=="npc_fastzombie" or attacker:GetClass()=="npc_fastzombie_torso" then dmginfo:SetDamage(18) end
		end
	end
end

function hl2s_PlayerDamaged(ply, hitgroup, dmginfo)
	if GetConVarNumber("hl2s_difficulty")>0 then
		if #player.GetAll()>1 then
			local hl2s_diff = (#player.GetAll()/12)
			if hitgroup == HITGROUP_LEFTARM or hitgroup == HITGROUP_RIGHTARM or hitgroup == HITGROUP_LEFTLEG or hitgroup == HITGROUP_RIGHTLEG or hitgroup == HITGROUP_GEAR then
				dmginfo:ScaleDamage(math.Clamp(0.8+hl2s_diff, 0.8, 1.5))
			else
				dmginfo:ScaleDamage(math.Clamp(1+hl2s_diff, 1, 1.5))
			end
		else
			if hitgroup == HITGROUP_LEFTARM or hitgroup == HITGROUP_RIGHTARM or hitgroup == HITGROUP_LEFTLEG or hitgroup == HITGROUP_RIGHTLEG or hitgroup == HITGROUP_GEAR then
				dmginfo:ScaleDamage(0.8)
			else
				dmginfo:ScaleDamage(1)
			end
		end
		if ( hitgroup == HITGROUP_HEAD ) then
			dmginfo:SetDamage(dmginfo:GetDamage()/2)
		end
	end
end

function hl2s_NpcDamaged(npc, hitgroup, dmginfo)
	if GetConVarNumber("hl2s_difficulty")>0 then
		if #player.GetAll()>1 then
			local hl2s_diff = (#player.GetAll()/12)
			if ( hitgroup == HITGROUP_HEAD ) then
				dmginfo:SetDamage(math.Clamp(2-hl2s_diff, 1, 2)*(dmginfo:GetDamage()/10))
			elseif hitgroup == HITGROUP_LEFTARM or hitgroup == HITGROUP_RIGHTARM or hitgroup == HITGROUP_LEFTLEG or hitgroup == HITGROUP_RIGHTLEG or hitgroup == HITGROUP_GEAR then
				dmginfo:ScaleDamage(math.Clamp(0.6-hl2s_diff, 0.4, 0.6))
			else
				dmginfo:ScaleDamage(math.Clamp(0.8-hl2s_diff, 0.4, 0.8))
			end
		else
			if ( hitgroup == HITGROUP_HEAD ) then
				dmginfo:SetDamage(2*(dmginfo:GetDamage()/10))
			elseif hitgroup == HITGROUP_LEFTARM or hitgroup == HITGROUP_RIGHTARM or hitgroup == HITGROUP_LEFTLEG or hitgroup == HITGROUP_RIGHTLEG or hitgroup == HITGROUP_GEAR then
				dmginfo:ScaleDamage(0.6)
			else
				dmginfo:ScaleDamage(0.8)
			end
		end
	end
end

hook.Add( "EntityTakeDamage", "HL2s-DamagedSomething", hl2s_DamagedSomething )
hook.Add( "ScalePlayerDamage", "HL2s-PlayerDamaged", hl2s_PlayerDamaged )
hook.Add( "ScaleNPCDamage", "HL2s-NpcDamaged", hl2s_NpcDamaged )

function hl2s_Think()
	if hl2s_NextTupdate==nil then hl2s_NextTupdate=CurTime() end
	if GetConVarNumber("hl2s_difficulty")>0 and hl2s_NextTupdate<CurTime() then
		for k,v in pairs(ents.GetAll()) do
			if v and v:IsValid() and v:IsNPC() then
				if (v:GetClass()=="npc_citizen" or v:GetClass()=="npc_metropolice") then
					if v:GetCurrentWeaponProficiency()!=WEAPON_PROFICIENCY_GOOD then
						v:SetCurrentWeaponProficiency(WEAPON_PROFICIENCY_GOOD)
					end
				else
					if v:GetCurrentWeaponProficiency()!=WEAPON_PROFICIENCY_VERY_GOOD then
						v:SetCurrentWeaponProficiency(WEAPON_PROFICIENCY_VERY_GOOD)
					end
				end
			end
		end
		hl2s_NextTupdate=CurTime()+3
	end

	if hl2s_difficulty_change==nil then hl2s_difficulty_change=GetConVarNumber("hl2s_difficulty") end
	if hl2s_difficulty_change!=GetConVarNumber("hl2s_difficulty") then
		if GetConVarNumber("hl2s_difficulty")>0 then
			for k,v in pairs(player.GetAll()) do
				if GetConVarNumber("hl2s_difficulty")>1 then
					v:PrintMessage(HUD_PRINTTALK, "Difficulty is now set to Extra Hard Difficulty\n")
				else
					v:PrintMessage(HUD_PRINTTALK, "Difficulty is now set to HL2's Difficulty\n")
				end
			end
			HL2s_HL2Difficulty()
			if GetConVarNumber("hl2s_difficulty")>1 then
				HL2s_ImpDifficulty()
			end
		else
			for k,v in pairs(player.GetAll()) do
				v:PrintMessage(HUD_PRINTTALK, "Difficulty has been reset to gmod's default difficulty\n")
			end
			HL2s_GmodDifficulty()
		end
		hl2s_difficulty_change=GetConVarNumber("hl2s_difficulty")
	end

	if hl2s_speed_change==nil then hl2s_speed_change=GetConVarNumber("hl2s_speed") end
	if hl2s_speed_change!=GetConVarNumber("hl2s_speed") then
		if GetConVarNumber("hl2s_speed")>0 then
			for k,v in pairs(player.GetAll()) do
				v:PrintMessage(HUD_PRINTTALK, "Speed is now set to HL2's speed\n")
				GAMEMODE:SetPlayerSpeed(v, 190, 320)
			end
		else
			for k,v in pairs(player.GetAll()) do
				v:PrintMessage(HUD_PRINTTALK, "Speed has been reset to gmod's speed\n")
				GAMEMODE:SetPlayerSpeed(v, 250, 500)
			end
		end
		hl2s_speed_change=GetConVarNumber("hl2s_speed")
	end
	
	if hl2s_drowning_change==nil then hl2s_drowning_change=GetConVarNumber("hl2s_drowning") end
	if hl2s_drowning_change!=GetConVarNumber("hl2s_drowning") then
		for k,v in pairs(player.GetAll()) do
			v:PrintMessage(HUD_PRINTTALK, "Server Cvar drowning has been changed to "..GetConVarNumber("hl2s_drowning").."\n")
		end
		hl2s_drowning_change=GetConVarNumber("hl2s_drowning")
	end
	if hl2s_energy_change==nil then hl2s_energy_change=GetConVarNumber("hl2s_energy") end
	if hl2s_energy_change!=GetConVarNumber("hl2s_energy") then
		for k,v in pairs(player.GetAll()) do
			v:PrintMessage(HUD_PRINTTALK, "Server Cvar sprint energy has been changed to "..GetConVarNumber("hl2s_energy").."\n")
		end
		hl2s_energy_change=GetConVarNumber("hl2s_energy")
	end
	if hl2s_ammolimit_change==nil then hl2s_ammolimit_change=GetConVarNumber("hl2s_ammolimit") end
	if hl2s_ammolimit_change!=GetConVarNumber("hl2s_ammolimit") then
		for k,v in pairs(player.GetAll()) do
			v:PrintMessage(HUD_PRINTTALK, "Server Cvar ammo limits has been changed to "..GetConVarNumber("hl2s_ammolimit").."\n")
		end
		hl2s_ammolimit_change=GetConVarNumber("hl2s_ammolimit")
	end

	if hl2s_NextAupdate==nil then hl2s_NextAupdate=CurTime() end
	if hl2s_NextDupdate==nil then hl2s_NextDupdate=CurTime() end
	if hl2s_NextS1update==nil then hl2s_NextS1update=CurTime() end
	if hl2s_NextS2update==nil then hl2s_NextS2update=CurTime() end
	if hl2s_NextDSupdate==nil then hl2s_NextDSupdate=CurTime() end
	if (GetConVarNumber("hl2s_drowning")>0 or GetConVarNumber("hl2s_energy")>0 or GetConVarNumber("hl2s_ammolimit")>0) and hl2s_NextDSupdate<CurTime() then
		for pn,pl in pairs(player.GetAll()) do
			if pl and pl:IsValid() and pl:Alive() then
				if GetConVarNumber("hl2s_drowning")>0 then
					if pl.HL2s_PreDrown==nil then pl.HL2s_PreDrown=15 end
					if pl.HL2s_DrownAmount==nil then pl.HL2s_DrownAmount=100 end
					if pl:WaterLevel()==3 then
						if hl2s_NextDupdate<CurTime() then
							if pl.HL2s_PreDrown>0 then pl.HL2s_PreDrown=pl.HL2s_PreDrown-1 end
							if pl.HL2s_PreDrown<=0 then
								if pl.HL2s_DrownAmount>0 then pl.HL2s_DrownAmount=pl.HL2s_DrownAmount-10 end
								umsg.Start("HL2s-drown", pl)
								umsg.Short(pl.HL2s_DrownAmount)
								umsg.End()
								if pl.HL2s_DrownAmount<=0 then
									local DDmg = DamageInfo()
									DDmg:SetAttacker(pl)
									DDmg:SetInflictor(pl)
									DDmg:SetDamage(200)
									DDmg:SetDamageType(DMG_DROWN)
									pl:TakeDamageInfo(DDmg)
								end
							end
							hl2s_NextDupdate=CurTime()+1
						end
					else
						if pl.HL2s_PreDrown<=0 then
							umsg.Start("HL2s-undrown", pl)
							umsg.End()
						end
						pl.HL2s_PreDrown=15
						pl.HL2s_DrownAmount=100
					end
				end
				if GetConVarNumber("hl2s_energy")>0 then
					if GetConVarNumber("hl2s_speed")>0 then
						hl2s_walkspeed=190
						hl2s_sprintspeed=320
					else
						hl2s_walkspeed=250
						hl2s_sprintspeed=500
					end
					if pl.HL2s_SprintTime==nil then pl.HL2s_SprintTime=14 end
					if pl.HL2s_SprintDisabled==nil then pl.HL2s_SprintDisabled=0 end
					local hl2s_pljumped=pl:KeyDown(IN_JUMP)
					if !pl:InVehicle() and (pl:OnGround() or hl2s_pljumped or pl:WaterLevel()>0) and (pl:GetVelocity():Length()>hl2s_sprintspeed-65 and pl:KeyDown(IN_SPEED)) then
						if hl2s_NextS1update<CurTime() and pl.HL2s_SprintDisabled!=1 then
							if pl.HL2s_SprintTime>0 then
								if hl2s_pljumped then
									pl.HL2s_SprintTime=pl.HL2s_SprintTime-4
								else
									pl.HL2s_SprintTime=pl.HL2s_SprintTime-1
								end
							end
							umsg.Start("HL2s-updatesprint", pl)
							umsg.Short(pl.HL2s_SprintTime)
							umsg.End()
							if pl.HL2s_SprintTime<=0 and pl.HL2s_SprintDisabled!=1 then
								GAMEMODE:SetPlayerSpeed(pl, hl2s_walkspeed, hl2s_walkspeed)
								pl.HL2s_SprintDisabled=1
							end
							hl2s_NextS1update=CurTime()+0.5
						end
					else
						if pl.HL2s_SprintTime<=2 and pl.HL2s_SprintDisabled!=1 then
							GAMEMODE:SetPlayerSpeed(pl, hl2s_walkspeed, hl2s_walkspeed)
							pl.HL2s_SprintDisabled=1
						end
						if hl2s_NextS2update<CurTime() then
							if pl.HL2s_SprintTime<14 then
								pl.HL2s_SprintTime=pl.HL2s_SprintTime+1
								umsg.Start("HL2s-updatesprint", pl)
								umsg.Short(pl.HL2s_SprintTime)
								umsg.End()
							end
							hl2s_NextS2update=CurTime()+1
						end
					end
					if pl.HL2s_SprintTime>2 and pl.HL2s_SprintDisabled==1 then
						GAMEMODE:SetPlayerSpeed(pl, hl2s_walkspeed, hl2s_sprintspeed)
						pl.HL2s_SprintDisabled=0
					end
				end
				if GetConVarNumber("hl2s_ammolimit")>0 then
					if pl:GetAmmoCount("357")>hl2s_maxammo_357 then
						if pl:GetAmmoCount("357")-hl2s_maxammo_357==6 then
							local ent = ents.Create("item_ammo_357")
							ent:SetPos(pl:GetPos())
							timer.Simple(1.5, function()
								if ent and ent:IsValid() then
									ent:Spawn()
									ent:Activate()
								end
							end)
						end
						pl:RemoveAmmo( pl:GetAmmoCount("357")-hl2s_maxammo_357, "357" )
					end
					if pl:GetAmmoCount("AR2")>hl2s_maxammo_AR2 then
						if pl:GetAmmoCount("AR2")-hl2s_maxammo_AR2==20 then
							local ent = ents.Create("item_ammo_ar2")
							ent:SetPos(pl:GetPos())
							timer.Simple(1.5, function()
								if ent and ent:IsValid() then
									ent:Spawn()
									ent:Activate()
								end
							end)
						end
						pl:RemoveAmmo( pl:GetAmmoCount("AR2")-hl2s_maxammo_AR2, "AR2" )
					end
					if pl:GetAmmoCount("AR2AltFire")>hl2s_maxammo_AR2AltFire then
						pl:RemoveAmmo( pl:GetAmmoCount("AR2AltFire")-hl2s_maxammo_AR2AltFire, "AR2AltFire" )
					end
					if pl:GetAmmoCount("Buckshot")>hl2s_maxammo_Buckshot then
						if pl:GetAmmoCount("Buckshot")-hl2s_maxammo_Buckshot==20 then
							local ent = ents.Create("item_box_buckshot")
							ent:SetPos(pl:GetPos())
							timer.Simple(1.5, function()
								if ent and ent:IsValid() then
									ent:Spawn()
									ent:Activate()
								end
							end)
						end
						pl:RemoveAmmo( pl:GetAmmoCount("Buckshot")-hl2s_maxammo_Buckshot, "Buckshot" )
					end
					if pl:GetAmmoCount("XBowBolt")>hl2s_maxammo_XBowBolt then
						if pl:GetAmmoCount("XBowBolt")-hl2s_maxammo_XBowBolt==6 then
							local ent = ents.Create("item_ammo_crossbow")
							ent:SetPos(pl:GetPos())
							timer.Simple(1.5, function()
								if ent and ent:IsValid() then
									ent:Spawn()
									ent:Activate()
								end
							end)
						end
						pl:RemoveAmmo( pl:GetAmmoCount("XBowBolt")-hl2s_maxammo_XBowBolt, "XBowBolt" )
					end
					if pl:GetAmmoCount("Grenade")>hl2s_maxammo_Grenade then
						pl:RemoveAmmo( pl:GetAmmoCount("Grenade")-hl2s_maxammo_Grenade, "Grenade" )
					end
					if pl:GetAmmoCount("slam")>hl2s_maxammo_slam then
						if pl:GetAmmoCount("slam")-hl2s_maxammo_slam==3 then
							local ent = ents.Create("weapon_slam")
							ent:SetPos(pl:GetPos())
							timer.Simple(1.5, function()
								if ent and ent:IsValid() then
									ent:Spawn()
									ent:Activate()
								end
							end)
						end
						pl:RemoveAmmo( pl:GetAmmoCount("slam")-hl2s_maxammo_slam, "slam" )
					end
					if pl:GetAmmoCount("Pistol")>hl2s_maxammo_Pistol then
						if pl:GetAmmoCount("Pistol")-hl2s_maxammo_Pistol==38 then
							local ent = ents.Create("item_ammo_pistol")
							ent:SetPos(pl:GetPos())
							timer.Simple(1.5, function()
								if ent and ent:IsValid() then
									ent:Spawn()
									ent:Activate()
								end
							end)
						end
						pl:RemoveAmmo( pl:GetAmmoCount("Pistol")-hl2s_maxammo_Pistol, "Pistol" )
					end
					if pl:GetAmmoCount("RPG_Round")>hl2s_maxammo_RPG_Round then
						pl:RemoveAmmo( pl:GetAmmoCount("RPG_Round")-hl2s_maxammo_RPG_Round, "RPG_Round" )
					end
					if pl:GetAmmoCount("SMG1")>hl2s_maxammo_SMG1 then
						if pl:GetAmmoCount("SMG1")-hl2s_maxammo_SMG1==45 then
							local ent = ents.Create("item_ammo_smg1")
							ent:SetPos(pl:GetPos())
							timer.Simple(1.5, function()
								if ent and ent:IsValid() then
									ent:Spawn()
									ent:Activate()
								end
							end)
						end
						pl:RemoveAmmo( pl:GetAmmoCount("SMG1")-hl2s_maxammo_SMG1, "SMG1" )
					end
					if pl:GetAmmoCount("SMG1_Grenade")>hl2s_maxammo_SMG1_Grenade then
						pl:RemoveAmmo( pl:GetAmmoCount("SMG1_Grenade")-hl2s_maxammo_SMG1_Grenade, "SMG1_Grenade" )
					end
				end
			end
		end
		hl2s_NextDSupdate=CurTime()+0.2
	end

end
hook.Add( "Think", "HL2s-Think", hl2s_Think )

function HL2s_GmodDifficulty()
	for k,v in pairs(ents.GetAll()) do
		if v and v:IsValid() and v:IsNPC() then
			if v:GetClass()=="npc_combine_s" or v:GetClass()=="npc_metropolice" then
				if v:GetCurrentWeaponProficiency()!=WEAPON_PROFICIENCY_AVERAGE then
					v:SetCurrentWeaponProficiency(WEAPON_PROFICIENCY_AVERAGE)
				end
			else
				if v:GetCurrentWeaponProficiency()!=WEAPON_PROFICIENCY_VERY_GOOD then
					v:SetCurrentWeaponProficiency(WEAPON_PROFICIENCY_VERY_GOOD)
				end
			end
		end
	end
	game.ConsoleCommand("skill 1\n")
	game.ConsoleCommand("sk_antlion_air_attack_dmg 10\n")
	game.ConsoleCommand("sk_antlion_health 30\n")
	game.ConsoleCommand("sk_antlion_jump_damage 5\n")
	game.ConsoleCommand("sk_antlion_swipe_damage 5\n")
	game.ConsoleCommand("sk_antlion_worker_burst_damage 50\n")
	game.ConsoleCommand("sk_antlion_worker_health 60\n")
	game.ConsoleCommand("sk_antlion_worker_spit_grenade_dmg 20\n")
	game.ConsoleCommand("sk_antlionguard_dmg_charge 20\n")
	game.ConsoleCommand("sk_antlionguard_dmg_shove 10\n")
	game.ConsoleCommand("sk_apc_missile_damage 50\n")
	game.ConsoleCommand("sk_barnacle_health 35\n")
	game.ConsoleCommand("sk_citizen_giveammo_player_delay 10\n")
	game.ConsoleCommand("sk_citizen_heal_ally 30\n")
	game.ConsoleCommand("sk_citizen_heal_ally_delay 20\n")
	game.ConsoleCommand("sk_citizen_heal_player 25\n")
	game.ConsoleCommand("sk_citizen_heal_player_delay 25\n")
	game.ConsoleCommand("sk_combine_guard_health 70\n")
	game.ConsoleCommand("sk_combine_s_health 50\n")
	game.ConsoleCommand("sk_headcrab_fast_health 10\n")
	game.ConsoleCommand("sk_headcrab_health 10\n")
	game.ConsoleCommand("sk_headcrab_melee_dmg 5\n")
	game.ConsoleCommand("sk_headcrab_poison_health 35\n")
	game.ConsoleCommand("sk_hunter_health 210\n")
	game.ConsoleCommand("sk_hunter_dmg_charge 20\n")
	game.ConsoleCommand("sk_hunter_dmg_flechette 4\n")
	game.ConsoleCommand("sk_hunter_dmg_one_slash 20\n")
	game.ConsoleCommand("sk_hunter_flechette_explode_dmg 12\n")
	game.ConsoleCommand("sk_jeep_gauss_damage 15\n")
	game.ConsoleCommand("sk_manhack_health 25\n")
	game.ConsoleCommand("sk_manhack_melee_dmg 20\n")
	game.ConsoleCommand("sk_metropolice_health 40\n")
	game.ConsoleCommand("sk_npc_dmg_ar2 3\n")
	game.ConsoleCommand("sk_npc_dmg_buckshot 3\n")
	game.ConsoleCommand("sk_npc_dmg_combineball 15\n")
	game.ConsoleCommand("sk_npc_dmg_crossbow 10\n")
	game.ConsoleCommand("sk_npc_dmg_fraggrenade 75\n")
	game.ConsoleCommand("sk_npc_dmg_grenade 75\n")
	game.ConsoleCommand("sk_npc_dmg_gunship_to_plr 3\n")
	game.ConsoleCommand("sk_npc_dmg_helicopter_to_plr 3\n")
	game.ConsoleCommand("sk_npc_dmg_pistol 3\n")
	game.ConsoleCommand("sk_npc_dmg_smg1 3\n")
	game.ConsoleCommand("sk_npc_dmg_smg1_grenade 50\n")
	game.ConsoleCommand("sk_npc_dmg_sniper_round 100\n")
	game.ConsoleCommand("sk_plr_dmg_357 40\n")
	game.ConsoleCommand("sk_plr_dmg_airboat 3\n")
	game.ConsoleCommand("sk_plr_dmg_ar2 8\n")
	game.ConsoleCommand("sk_plr_dmg_buckshot 8\n")
	game.ConsoleCommand("sk_plr_dmg_crossbow 100\n")
	game.ConsoleCommand("sk_plr_dmg_crowbar 10\n")
	game.ConsoleCommand("sk_plr_dmg_fraggrenade 125\n")
	game.ConsoleCommand("sk_plr_dmg_grenade 150\n")
	game.ConsoleCommand("sk_plr_dmg_pistol 5\n")
	game.ConsoleCommand("sk_plr_dmg_smg1 4\n")
	game.ConsoleCommand("sk_plr_dmg_smg1_grenade 100\n")
	game.ConsoleCommand("sk_plr_dmg_stunstick 10\n")
	game.ConsoleCommand("sk_rollermine_shock 10\n")
	game.ConsoleCommand("sk_strider_health 350\n")
	game.ConsoleCommand("sk_vortigaunt_dmg_claw 10\n")
	game.ConsoleCommand("sk_vortigaunt_dmg_rake 25\n")
	game.ConsoleCommand("sk_vortigaunt_dmg_zap 25\n")
	game.ConsoleCommand("sk_zombie_dmg_both_slash 25\n")
	game.ConsoleCommand("sk_zombie_dmg_one_slash 10\n")
	game.ConsoleCommand("sk_zombie_health 50\n")
	game.ConsoleCommand("sk_healthkit 25\n")
	game.ConsoleCommand("sk_healthvial 10\n")
	game.ConsoleCommand("sk_healthcharger 50\n")
	game.ConsoleCommand("sk_suitcharger 30\n")
	game.ConsoleCommand("sk_battery 15\n")
end

function HL2s_HL2Difficulty()
	for k,v in pairs(ents.GetAll()) do
		if v and v:IsValid() and v:IsNPC() then
			if (v:GetClass()=="npc_citizen" or v:GetClass()=="npc_metropolice") and #player.GetAll()>4 then
				if v:GetCurrentWeaponProficiency()!=WEAPON_PROFICIENCY_GOOD then
					v:SetCurrentWeaponProficiency(WEAPON_PROFICIENCY_GOOD)
				end
			else
				if v:GetCurrentWeaponProficiency()!=WEAPON_PROFICIENCY_VERY_GOOD then
					v:SetCurrentWeaponProficiency(WEAPON_PROFICIENCY_VERY_GOOD)
				end
			end
		end
	end
	game.ConsoleCommand("skill 3\n")
	game.ConsoleCommand("sk_antlion_air_attack_dmg 30\n")
	game.ConsoleCommand("sk_antlion_health 70\n")
	game.ConsoleCommand("sk_antlion_jump_damage 15\n")
	game.ConsoleCommand("sk_antlion_swipe_damage 15\n")
	game.ConsoleCommand("sk_antlion_worker_burst_damage 70\n")
	game.ConsoleCommand("sk_antlion_worker_health 80\n")
	game.ConsoleCommand("sk_antlion_worker_spit_grenade_dmg 35\n")
	game.ConsoleCommand("sk_antlionguard_dmg_charge 110\n")
	game.ConsoleCommand("sk_antlionguard_dmg_shove 85\n")
	game.ConsoleCommand("sk_apc_missile_damage 65\n")
	game.ConsoleCommand("sk_barnacle_health 55\n")
	game.ConsoleCommand("sk_citizen_giveammo_player_delay 5\n")
	game.ConsoleCommand("sk_citizen_heal_ally 50\n")
	game.ConsoleCommand("sk_citizen_heal_ally_delay 20\n")
	game.ConsoleCommand("sk_citizen_heal_player 50\n")
	game.ConsoleCommand("sk_citizen_heal_player_delay 10\n")
	game.ConsoleCommand("sk_combine_guard_health 70\n")
	game.ConsoleCommand("sk_combine_s_health 60\n")
	game.ConsoleCommand("sk_headcrab_fast_health 20\n")
	game.ConsoleCommand("sk_headcrab_health 15\n")
	game.ConsoleCommand("sk_headcrab_melee_dmg 10\n")
	game.ConsoleCommand("sk_headcrab_poison_health 35\n")
	game.ConsoleCommand("sk_hunter_health 360\n")
	game.ConsoleCommand("sk_hunter_dmg_charge 54\n")
	game.ConsoleCommand("sk_hunter_dmg_flechette 6\n")
	game.ConsoleCommand("sk_hunter_dmg_one_slash 36\n")
	game.ConsoleCommand("sk_hunter_flechette_explode_dmg 18\n")
	game.ConsoleCommand("sk_jeep_gauss_damage 18\n")
	game.ConsoleCommand("sk_manhack_health 45\n")
	game.ConsoleCommand("sk_manhack_melee_dmg 22\n")
	game.ConsoleCommand("sk_metropolice_health 50\n")
	game.ConsoleCommand("sk_npc_dmg_ar2 9\n")
	game.ConsoleCommand("sk_npc_dmg_buckshot 9\n")
	game.ConsoleCommand("sk_npc_dmg_combineball 140\n")
	game.ConsoleCommand("sk_npc_dmg_crossbow 100\n")
	game.ConsoleCommand("sk_npc_dmg_fraggrenade 125\n")
	game.ConsoleCommand("sk_npc_dmg_grenade 150\n")
	game.ConsoleCommand("sk_npc_dmg_gunship_to_plr 6\n")
	game.ConsoleCommand("sk_npc_dmg_helicopter_to_plr 6\n")
	game.ConsoleCommand("sk_npc_dmg_pistol 6\n")
	game.ConsoleCommand("sk_npc_dmg_smg1 6\n")
	game.ConsoleCommand("sk_npc_dmg_smg1_grenade 85\n")
	game.ConsoleCommand("sk_npc_dmg_sniper_round 130\n")
	game.ConsoleCommand("sk_plr_dmg_357 40\n")
	game.ConsoleCommand("sk_plr_dmg_airboat 4\n")
	game.ConsoleCommand("sk_plr_dmg_ar2 9\n")
	game.ConsoleCommand("sk_plr_dmg_buckshot 16\n")
	game.ConsoleCommand("sk_plr_dmg_crossbow 100\n")
	game.ConsoleCommand("sk_plr_dmg_crowbar 15\n")
	game.ConsoleCommand("sk_plr_dmg_fraggrenade 125\n")
	game.ConsoleCommand("sk_plr_dmg_grenade 150\n")
	game.ConsoleCommand("sk_plr_dmg_pistol 6\n")
	game.ConsoleCommand("sk_plr_dmg_smg1 6\n")
	game.ConsoleCommand("sk_plr_dmg_smg1_grenade 100\n")
	game.ConsoleCommand("sk_plr_dmg_stunstick 20\n")
	game.ConsoleCommand("sk_rollermine_shock 15\n")
	game.ConsoleCommand("sk_strider_health 450\n")
	game.ConsoleCommand("sk_vortigaunt_dmg_claw 20\n")
	game.ConsoleCommand("sk_vortigaunt_dmg_rake 35\n")
	game.ConsoleCommand("sk_vortigaunt_dmg_zap 55\n")
	game.ConsoleCommand("sk_zombie_dmg_both_slash 35\n")
	game.ConsoleCommand("sk_zombie_dmg_one_slash 24\n")
	game.ConsoleCommand("sk_zombie_health 60\n")
	game.ConsoleCommand("sk_healthkit 50\n")
	game.ConsoleCommand("sk_healthvial 25\n")
	game.ConsoleCommand("sk_healthcharger 100\n")
	game.ConsoleCommand("sk_suitcharger 50\n")
	game.ConsoleCommand("sk_battery 25\n")
end

function HL2s_ImpDifficulty()
	game.ConsoleCommand("sk_antlion_air_attack_dmg 107\n")
	game.ConsoleCommand("sk_antlion_jump_damage 78\n")
	game.ConsoleCommand("sk_antlion_swipe_damage 69\n")
	game.ConsoleCommand("sk_antlion_worker_burst_damage 118\n")
	game.ConsoleCommand("sk_antlion_worker_spit_grenade_dmg 92\n")
	game.ConsoleCommand("sk_antlionguard_dmg_charge 144\n")
	game.ConsoleCommand("sk_antlionguard_dmg_shove 126\n")
	game.ConsoleCommand("sk_apc_missile_damage 136\n")
	game.ConsoleCommand("sk_headcrab_melee_dmg 110\n")
	game.ConsoleCommand("sk_hunter_dmg_charge 104\n")
	game.ConsoleCommand("sk_hunter_dmg_flechette 16\n")
	game.ConsoleCommand("sk_hunter_dmg_one_slash 88\n")
	game.ConsoleCommand("sk_hunter_flechette_explode_dmg 36\n")
	game.ConsoleCommand("sk_jeep_gauss_damage 36\n")
	game.ConsoleCommand("sk_manhack_melee_dmg 48\n")
	game.ConsoleCommand("sk_npc_dmg_ar2 14\n")
	game.ConsoleCommand("sk_npc_dmg_buckshot 12\n")
	game.ConsoleCommand("sk_npc_dmg_combineball 180\n")
	game.ConsoleCommand("sk_npc_dmg_crossbow 130\n")
	game.ConsoleCommand("sk_npc_dmg_fraggrenade 135\n")
	game.ConsoleCommand("sk_npc_dmg_grenade 160\n")
	game.ConsoleCommand("sk_npc_dmg_gunship_to_plr 12\n")
	game.ConsoleCommand("sk_npc_dmg_helicopter_to_plr 12\n")
	game.ConsoleCommand("sk_npc_dmg_pistol 12\n")
	game.ConsoleCommand("sk_npc_dmg_smg1 12\n")
	game.ConsoleCommand("sk_npc_dmg_smg1_grenade 160\n")
	game.ConsoleCommand("sk_npc_dmg_sniper_round 160\n")
	game.ConsoleCommand("sk_npc_dmg_stunstick 46\n")
	game.ConsoleCommand("sk_rollermine_shock 65\n")
	game.ConsoleCommand("sk_vortigaunt_dmg_claw 55\n")
	game.ConsoleCommand("sk_vortigaunt_dmg_rake 85\n")
	game.ConsoleCommand("sk_vortigaunt_dmg_zap 125\n")
	game.ConsoleCommand("sk_zombie_dmg_both_slash 87\n")
	game.ConsoleCommand("sk_zombie_dmg_one_slash 64\n")
	game.ConsoleCommand("sk_citizen_heal_ally 100\n")
	game.ConsoleCommand("sk_citizen_heal_ally_delay 20\n")
	game.ConsoleCommand("sk_citizen_heal_player 100\n")
	game.ConsoleCommand("sk_citizen_heal_player_delay 20\n")
	game.ConsoleCommand("sk_healthkit 100\n")
	game.ConsoleCommand("sk_healthvial 50\n")
	game.ConsoleCommand("sk_healthcharger 200\n")
	game.ConsoleCommand("sk_suitcharger 100\n")
	game.ConsoleCommand("sk_battery 50\n")
end

		end

		if CLIENT then

function HL2s_hud()
	if LocalPlayer() and LocalPlayer():IsValid() and LocalPlayer():Alive() then
		if GetConVarNumber("hl2s_drowning")>0 then
			if hl2s_drownalpha!=nil and hl2s_drownalpha>0 and hl2s_drownalpha<250 then
				surface.SetDrawColor(40,40,200,hl2s_drownalpha)
				surface.DrawRect(0,0,ScrW(),ScrH())
			end
		end
		if GetConVarNumber("hl2s_energy")>0 then
			if hl2s_plsprinttime!=nil and hl2s_plsprinttime>0 and hl2s_plsprinttime<14 then
				surface.SetDrawColor(0,0,0,75)
				surface.DrawRect(10,(ScrH()-ScrH()/8)-15,140,20)
				surface.SetDrawColor(230,200,30,150)
				surface.DrawRect(15,(ScrH()-ScrH()/8)-10,hl2s_plsprinttime*10,10)
			end
		end
	end
end
hook.Add( "HUDPaint", "HL2s-hud", HL2s_hud )

function HL2s_drown(um)
	local dramount=um:ReadShort()
	if dramount>60 and dramount<=100 then surface.PlaySound("player/pl_drown3.wav") end
	if dramount>20 and dramount<=60 then surface.PlaySound("player/pl_drown2.wav") end
	if dramount>=0 and dramount<=20 then surface.PlaySound("player/pl_drown1.wav") end
	hl2s_drownalpha = math.Clamp((100-dramount)*2.55,0,255)
end
usermessage.Hook("HL2s-drown", HL2s_drown)

function HL2s_undrown(um)
	hl2s_drownalpha=0
end
usermessage.Hook("HL2s-undrown", HL2s_undrown)

function HL2s_updatesprint(um)
	hl2s_plsprinttime=um:ReadShort()
end
usermessage.Hook("HL2s-updatesprint", HL2s_updatesprint)

local function hl2s_menu( panel )
	if !LocalPlayer():IsSuperAdmin() then
		panel:AddControl( "Header", {Text = "You are not a super admin!"})
		panel:AddControl( "Label", {Text = "Only super admins can view this menu."})
		return
	end
	panel:AddControl("Checkbox", {Label = "FallDamage", Command = "mp_falldamage"})
	panel:AddControl("Checkbox", {Label = "HL2's Speed", Command = "hl2s_speed"})
	panel:AddControl("Checkbox", {Label = "Ammo Limits", Command = "hl2s_ammolimit"})
	panel:AddControl("Checkbox", {Label = "Sprint Energy", Command = "hl2s_energy"})
	panel:AddControl("Checkbox", {Label = "Drowning", Command = "hl2s_drowning"})
	panel:AddControl("Checkbox", {Label = "Flashlight", Command = "mp_flashlight"})
	panel:AddControl("Label", {Text = " "})
	panel:AddControl("Label", {Text = "Change the Difficulty:"})
	panel:AddControl("Button", {Label = "Gmod's Difficulty", Command = "hl2s_difficulty 0"})
	panel:AddControl("Button", {Label = "HL2's Difficulty", Command = "hl2s_difficulty 1"})
	panel:AddControl("Button", {Label = "Extra Hard Difficulty", Command = "hl2s_difficulty 2"})
end

function hl2s_AddToMenu()
	spawnmenu.AddToolMenuOption( "Utilities", "Game Settings", "HL2 Settings", "HL2 Settings", "", "", hl2s_menu, {} )
end
hook.Add( "PopulateToolMenu", "HL2s_menu", hl2s_AddToMenu )

		end